#include <stdlib.h>
#include <stdio.h>
#include "svg.h"
#include "dag.h"
#include "operation.h"

DagNode*
delaunay (Point2 ** S, int n, Triangle ** triangles)
{
	printHeader();
  //Criar os pontos artificiais   e incluir na triangulacao inicial
  DagNode *root = createArtifitialPoints (S, n);

  //Para cada ponto p de S
  int i;
  for (i = 0; i < n; i++)
    {
      //insere p na triangulacao tri
      Vertex *v = makeVertex (S[i]);
      //encontra o triangulo p1p2p3 onde p está
      DagNode *child = findTriangle (v, root);

      //se P está no interior  (em nosso caso p sempre esta no interior)
      //adiciona arestas de p aos tres vertices p1 p2 p3 
      // Spliting de p1p2p3 em tres triangulos
      split (v, child);

      // legaliza as tres arestas 
      legalize_edge (v, child->children[0]->t->e3,
		     getTriangle (child->children[0]->t->e3, v), root);
      legalize_edge (v, child->children[1]->t->e3,
		     getTriangle (child->children[1]->t->e3, v), root);
      legalize_edge (v, child->children[2]->t->e3,
		     getTriangle (child->children[2]->t->e3, v), root);
    }
	printFooter();
	return root;
}

