#ifndef TOPOLOGY_
#define TOPOLOGY_

#include "geometry.h"

typedef struct Vertex Vertex;
typedef struct Edge Edge;
typedef struct Triangle Triangle;

struct Vertex
{
  Point2 *point;
  int artificial;
};

struct Edge
{
  Vertex *v1, *v2;
  Triangle *t1, *t2;
};

struct Triangle
{
  Vertex *v1, *v2, *v3;
  Edge *e1, *e2, *e3;
};

// Criação de tipos
Edge *makeEdge (Vertex * v1, Vertex * v2);
Vertex *makeVertex (Point2 * point);
Triangle *makeTriangle (Vertex * v1, Vertex * v2, Vertex * v3);
void freeTriangle(Triangle *t);
void freeEdge(Edge *e);
void freeVertex(Vertex *v);

// Operações topológicas
Vertex *getOpposedVertex (Edge * e, Triangle * t);
Edge *getTriangleEdge (Vertex * v1, Vertex * v2, Triangle * t);
Triangle *getTriangle (Edge * e, Vertex * v);
Triangle *getOpposedTriangle (Edge * e, Triangle * t);

#endif /*TOPOLOGY_ */
